
#ifndef BROWSER_H_
#define BROWSER_H_

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <objbase.h>
#include <exdisp.h>
#include "String.h"

class Browser : public IOleClientSite, IOleInPlaceSite, DWebBrowserEvents2
{
public:	//incapsulation rulez ;)

	//---------------------------------------------------------------------------------
	//browser interface pointers
	IOleInPlaceObject			*pOleInPlaceObject;
	IWebBrowser2				*pWebBrowser2;
	IOleObject					*pOleObject;
	
	//events
	IConnectionPointContainer	*pCPC;
	IConnectionPoint			*pCP;
	DWORD cookie;

	//subclassing
	WNDPROC						old_wnd_proc;	//old window procedure
	HWND						parent;			//parent window HWND
	
	String						handler;		//event-handling alias

	//---------------------------------------------------------------------------------
	//construction/destruction
	Browser();
	virtual ~Browser();

	//attaching detaching
	BOOL attach(HWND hParent, WNDPROC new_wnd_proc);
	void detach();
	
	//IDispatch
    HRESULT STDMETHODCALLTYPE GetTypeInfoCount(UINT __RPC_FAR *);
    HRESULT STDMETHODCALLTYPE GetTypeInfo(UINT,LCID,ITypeInfo __RPC_FAR *__RPC_FAR*);
    HRESULT STDMETHODCALLTYPE GetIDsOfNames(REFIID,LPOLESTR __RPC_FAR*,UINT,LCID,DISPID __RPC_FAR*);        
virtual HRESULT STDMETHODCALLTYPE Invoke(DISPID,REFIID,LCID,WORD,DISPPARAMS __RPC_FAR*,VARIANT __RPC_FAR*,EXCEPINFO __RPC_FAR*,UINT __RPC_FAR*) = 0;	

	//IOleClientSite
	HRESULT STDMETHODCALLTYPE SaveObject();
	HRESULT STDMETHODCALLTYPE GetMoniker(DWORD,DWORD,IMoniker __RPC_FAR *__RPC_FAR*);
	HRESULT STDMETHODCALLTYPE GetContainer(IOleContainer __RPC_FAR *__RPC_FAR*);
	HRESULT STDMETHODCALLTYPE ShowObject();
	HRESULT STDMETHODCALLTYPE OnShowWindow(BOOL);
	HRESULT STDMETHODCALLTYPE RequestNewObjectLayout();
	
	//IOleInPlaceSite
    HRESULT STDMETHODCALLTYPE CanInPlaceActivate();
	HRESULT STDMETHODCALLTYPE OnInPlaceActivate();
	HRESULT STDMETHODCALLTYPE OnUIActivate();
	HRESULT STDMETHODCALLTYPE GetWindowContext(IOleInPlaceFrame __RPC_FAR *__RPC_FAR*,IOleInPlaceUIWindow __RPC_FAR *__RPC_FAR*,LPRECT,LPRECT,LPOLEINPLACEFRAMEINFO);        
    HRESULT STDMETHODCALLTYPE Scroll(SIZE);
	HRESULT STDMETHODCALLTYPE OnUIDeactivate(BOOL);
	HRESULT STDMETHODCALLTYPE OnInPlaceDeactivate();
	HRESULT STDMETHODCALLTYPE DiscardUndoState();
	HRESULT STDMETHODCALLTYPE DeactivateAndUndo();
	HRESULT STDMETHODCALLTYPE OnPosRectChange(LPCRECT);
	
	//IOleWindow
	HRESULT STDMETHODCALLTYPE GetWindow(HWND __RPC_FAR*);
    HRESULT STDMETHODCALLTYPE ContextSensitiveHelp(BOOL);

	//IUnknown
	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID, __RPC_FAR void* __RPC_FAR*);
    ULONG STDMETHODCALLTYPE AddRef();
	ULONG STDMETHODCALLTYPE Release();
};

#endif