
#include "String.h"

String::String(char c)
{
	buffer = (char*)LocalAlloc(0,4);
	len = 1;
	buffer[1] = 0;
	*buffer = c;
}

String::String(const char *str)
{
	if (!str) str = "";
	len = lstrlen(str);
	buffer = (char*)LocalAlloc(0,len + 1);
	CopyMemory(buffer,str,len);
	buffer[len] = 0;
}

String::String(int number)
{
	buffer = (LPSTR)LocalAlloc(0,50);
	wsprintf(buffer,"%d",number);
	len = lstrlen(buffer);
}

String::String(LPCWSTR unicode)
{
	if (!unicode) unicode = L"";
	len = WideCharToMultiByte(CP_ACP,0,unicode,-1,0,0,0,0);
	buffer = (char*)LocalAlloc(0,len << 1);
	WideCharToMultiByte(CP_ACP,0,unicode,-1,buffer,len,0,0);
	buffer[--len] = 0;
}

void String::unicode(LPWSTR buf)
{
	MultiByteToWideChar(CP_ACP,0,buffer,-1,buf,len << 2 + 2);
}

String::String(const String &ref)
{
	len = ref.len;
	buffer = (char*)LocalAlloc(0,len << 1);
	CopyMemory(buffer,ref.buffer,len);
	buffer[len] = 0;
}

String &String::operator <=(const String &ref)
{
	if ((len + ref.len) >= (int)LocalSize(buffer))
	{
		char *newbuf = (char*)LocalAlloc(0,(len + ref.len) << 1);
		CopyMemory(newbuf,buffer,len);
		LocalFree(buffer);
		buffer = newbuf;
	}
	CopyMemory(buffer + len,ref.buffer,ref.len);
	len += ref.len;
	buffer[len] = 0;
	return *this;
}

String &String::operator =(const String &ref)
{
	len = ref.len;
	if (len >= (int)LocalSize(buffer))
	{
		LocalFree(buffer);
		buffer = (char*)LocalAlloc(0,len << 1);
	}
	CopyMemory(buffer,ref.buffer,len);
	buffer[len] = 0;
	return *this;
}

String operator <(const String &a,const String &b)
{
	return String(a) <= b;
}

String::String(double value,int precision)
{
	buffer = (LPSTR)LocalAlloc(0,50);
	wsprintf(buffer,"%f*",precision,value);
	len = lstrlen(buffer);
}