
#ifndef STRING_H_
#define STRING_H_

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#define mb(x) MessageBox(0,(String)x,0,0)

class String
{

protected:

	char *buffer;
	int len;

public:
	String(char);
	String(const char *ptr = "");
	String(int);
	String(double,int precision = 6);
	String(LPCWSTR);
	String(const String&);
	virtual	~String() { LocalFree(buffer); }
	
	String&			operator =(const String&);
	int				operator ==(const String &m) const { return !lstrcmp(buffer,m.buffer); }
	int				operator !=(const String &m) const { return lstrcmp(buffer,m.buffer); }
	String&			operator <=(const String&);
	friend String	operator <(const String&,const String&);
					operator char *() const { return buffer; }
	void			unicode(LPWSTR buffer);
	int				length() const { return len; }
};

#endif